(in-package 'types)

;;; type-hat :: Eqns * Type -> hatted-type
;;;
;;; This file is the continuation of hat_fns.lisp
;;; This is where the functions defined in hat_fns.lisp get called 
;;;


;;;
;;; The main lookup table

(defconstant *hatarray*
  (make-array '(11)
	      :initial-contents
	      (list #'hat-zero #'hat-one #'hat-union #'hat-inter #'hat-cons #'hat-func 
		    #'hat-var #'hat-bvar #'hat-not #'hat-dep #'hat-value )))
	      
;;; The auxiliary hatting function : applies the appropriate function

(defun type-hat-aux (typ Eqns) 
  (if (is-hattype typ) typ           ;; ^^x = ^x
    (funcall (aref *hatarray* (type-type typ)) typ Eqns)))
  

;;; The top level hatting function.
(defun type-hat (typ eqns)
  (type-hat-aux typ eqns))
