(in-package 'types)

;;;
;;; make file for the constraint solver    
;;;

(defvar *type-pathname* (concatenate 'string *path* "solver/"))


(ensure-package 'ptools)
(use-package '(system)) 

(defvar *type-load* t)
(defvar *type-files* '(
		       "ptools"
		       "btools"
		       "constants"
		       "defs"
		       "assume"
		       "substitution"
		       "queue"
		       "lookup"
		       "varset"
		       "constraints_adt"
		       "printer_fns"
		       "printer_tbl"
		       "pretty_printer_fns"
		       "pretty_printer_tbl"
		       "subset_fns"
		       "subset_tbl"
		       "alpha_subst_fns"
		       "alpha_subst_tbl"
		       "mktype"
		       "hat_fns"
		       "hat_tbl"
		       "constr"
		       "compl_fns"
		       "compl_tbl"
		       "tlv_fns"
		       "tlv_tbl"
		       "disjoint_fns"
		       "disjoint_tbl"
		       "equations"
		       "print_equations"
		       "inter_fns"
		       "inter_tbl"
		       "hom_fns"
		       "hom_tbl"
		       "empty_fns"
		       "empty_tbl"
		       "not_zero_fns"
		       "not_zero_tbl"
                       "constraints_fns"
  	               "constraints_tbl"
		       "reachable_fns"
		       "reachable_tbl"
		       "free_vars_reachable_fns"
		       "free_vars_reachable_tbl"
		       "pos_fns"
		       "pos_tbl"
		       "neg_fns"
		       "neg_tbl"
		       "inter_list_fns"
		       "inter_list_tbl"
		       "var_elim"
		       ))

(compile&load *type-compile* *type-load* *type-pathname* *type-files*)



