(in-package 'types)

;;;
;;; Functions for maintaining an environment of assumptions.
;;;
;;; Currently just implemented as association lists.  If this
;;; is too slow, we will have to do something fancier.
;;;

(defun assump-empty () nil)

(defun assump-add (key ans as) (acons key ans as))

(defun assump-has (a as) (assoc a as :test #'equal))

(defun assump-get (a as) (cdr (assoc a as :test #'equal)))
 
