(in-package 'types)

;;;
;;; This file is the continuation of inter_list_fns.lisp
;;;


(defconstant *ilarray*
  (make-array 11 :initial-contents 
              ;;        0         1          2          3         4          5
	      (list #'il-none #'il-none #'il-union #'il-inter #'il-cons  #'il-func 

		   ;;   6         7          8      9        10
		    #'il-var #'il-bvar #'il-none #'il-dep #'il-val)))


(defun il-aux (typ rl sofar eqns as)
  (if (is-hattype typ)
      sofar
    (funcall (aref *ilarray* (type-type typ)) typ rl sofar eqns as)))

(defun inter-list (typ rl eqns)
  (il-aux typ rl nil eqns (pair-assump-empty)))
